package org.dromara.monitoring.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.monitoring.domain.MonEquipmentList;
import org.dromara.monitoring.domain.bo.MonEquipmentListBo;
import org.dromara.monitoring.domain.vo.MonEquipmentListVo;
import org.dromara.monitoring.mapper.MonEquipmentListMapper;
import org.dromara.monitoring.service.IMonEquipmentListService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 设备列Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-25
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class MonEquipmentListServiceImpl implements IMonEquipmentListService {

    private final MonEquipmentListMapper baseMapper;

    /**
     * 查询设备列
     *
     * @param id 主键
     * @return 设备列
     */
    @Override
    public MonEquipmentListVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询设备列列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 设备列分页列表
     */
    @Override
    public TableDataInfo<MonEquipmentListVo> queryPageList(MonEquipmentListBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<MonEquipmentList> lqw = buildQueryWrapper(bo);
        Page<MonEquipmentListVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的设备列列表
     *
     * @param bo 查询条件
     * @return 设备列列表
     */
    @Override
    public List<MonEquipmentListVo> queryList(MonEquipmentListBo bo) {
        LambdaQueryWrapper<MonEquipmentList> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<MonEquipmentList> buildQueryWrapper(MonEquipmentListBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<MonEquipmentList> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(MonEquipmentList::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceSerial()), MonEquipmentList::getDeviceSerial, bo.getDeviceSerial());
        lqw.like(StringUtils.isNotBlank(bo.getDeviceName()), MonEquipmentList::getDeviceName, bo.getDeviceName());
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceType()), MonEquipmentList::getDeviceType, bo.getDeviceType());
        lqw.eq(bo.getStatus() != null, MonEquipmentList::getStatus, bo.getStatus());
        lqw.eq(bo.getDefence() != null, MonEquipmentList::getDefence, bo.getDefence());
        lqw.eq(StringUtils.isNotBlank(bo.getDeviceVersion()), MonEquipmentList::getDeviceVersion, bo.getDeviceVersion());
        lqw.eq(bo.getAddTime() != null, MonEquipmentList::getAddTime, bo.getAddTime());
        lqw.eq(StringUtils.isNotBlank(bo.getParentCategory()), MonEquipmentList::getParentCategory, bo.getParentCategory());
        lqw.eq(bo.getRiskLevel() != null, MonEquipmentList::getRiskLevel, bo.getRiskLevel());
        lqw.eq(StringUtils.isNotBlank(bo.getNetAddress()), MonEquipmentList::getNetAddress, bo.getNetAddress());
        return lqw;
    }

    /**
     * 新增设备列
     *
     * @param bo 设备列
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(MonEquipmentListBo bo) {
        MonEquipmentList add = MapstructUtils.convert(bo, MonEquipmentList.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改设备列
     *
     * @param bo 设备列
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(MonEquipmentListBo bo) {
        MonEquipmentList update = MapstructUtils.convert(bo, MonEquipmentList.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(MonEquipmentList entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除设备列信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
